import { ImportManager, ImportIdentifierInfo } from "../importManager";
import { Scope, ModuleScope } from "../scope";
import * as ESTree from "estree";
export declare type NameInfoTuple = [string, ImportIdentifierInfo | null];
export interface RefsToModuleExtractor {
    refsToModule: NameInfoTuple[];
}
export declare class PureDeclaratorTraverser implements RefsToModuleExtractor {
    readonly validatorDeclarator: ESTree.VariableDeclarator;
    readonly moduleScope: ModuleScope;
    readonly refsToModule: NameInfoTuple[];
    readonly relevantScopes: Scope[];
    readonly importManager: ImportManager;
    readonly ids: ESTree.Identifier[];
    constructor(validatorDeclarator: ESTree.VariableDeclarator, moduleScope: ModuleScope);
    private nodeContains;
}
export declare class ChildScopesTraverser implements RefsToModuleExtractor {
    readonly scope: Scope;
    readonly importManager: ImportManager;
    readonly refsToModule: NameInfoTuple[];
    constructor(scope: Scope, importManager: ImportManager);
    private traverse;
}
