import { VariableType } from "./variable";
import * as ESTree from "estree";
export declare class Definition {
    readonly type: VariableType;
    readonly name: ESTree.Pattern | null;
    readonly node: ESTree.Node;
    readonly parent?: ESTree.VariableDeclaration | ESTree.ImportDeclaration | ESTree.ExportDefaultDeclaration | undefined;
    readonly index?: number | undefined;
    readonly kind?: string | undefined;
    constructor(type: VariableType, name: ESTree.Pattern | null, node: ESTree.Node, parent?: ESTree.VariableDeclaration | ESTree.ImportDeclaration | ESTree.ExportDefaultDeclaration | undefined, index?: number | undefined, kind?: string | undefined);
}
export declare class ParameterDefinition extends Definition {
    readonly rest: boolean;
    constructor(name: ESTree.Identifier, node: ESTree.Node, index: number, rest: boolean);
}
